// ============================================================================
// Copyright (c) 2014 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//
//
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//

// --------------------------------------------------------------------
//
// Major Functions:	VIP camera demo
//
// --------------------------------------------------------------------
//
// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            :| Mod. Date :| Changes Made:
//   V1.0 :| Peli Li           :| 08/29/2011:| Initial Revision
// --------------------------------------------------------------------

module VIP_Camera
(
    //////// CLOCK //////////
	CLOCK_50,
	CLOCK2_50,
	CLOCK3_50,

	//////// KEY //////////
	KEY,
	
	//////// SW //////////
	SW,
	
	//////// LED //////////
	LEDG,
	LEDR,

	//////// SEG7 //////////
	HEX0,
	HEX1,
	HEX2,
	HEX3,
	HEX4,
	HEX5,
	HEX6,
	HEX7,
	
	//////// VGA //////////
	VGA_B,
	VGA_BLANK_N,
	VGA_CLK,
	VGA_G,
	VGA_HS,
	VGA_R,
	VGA_SYNC_N,
	VGA_VS,
	
	//////// Audio //////////
	AUD_ADCDAT,
	AUD_ADCLRCK,
	AUD_BCLK,
	AUD_DACDAT,
	AUD_DACLRCK,
	AUD_XCK,
	
	//////// I2C for Audio and Tv-Decode //////////
	I2C_SCLK,
	I2C_SDAT,
	
	//////// TV Decoder //////////
	TD_CLK27,
	TD_DATA,
	TD_HS,
	TD_RESET_N,
	TD_VS,

	//////// SDRAM //////////
	DRAM_ADDR,
	DRAM_BA,
	DRAM_CAS_N,
	DRAM_CKE,
	DRAM_CLK,
	DRAM_CS_N,
	DRAM_DQ,
	DRAM_DQM,
	DRAM_RAS_N,
	DRAM_WE_N,

	//////// SRAM //////////
	SRAM_ADDR,
	SRAM_CE_N,
	SRAM_DQ,
	SRAM_LB_N,
	SRAM_OE_N,
	SRAM_UB_N,
	SRAM_WE_N,

	//////// Flash //////////
	FL_ADDR,
	FL_CE_N,
	FL_DQ,
	FL_OE_N,
	FL_RST_N,
	FL_RY,
	FL_WE_N,
	FL_WP_N,
	
	//////// GPIO //////////
	LTM_ADC_PENIRQ_n,
	LTM_ADC_BUSY,
	LTM_ADC_DCLK,
	LTM_ADC_DIN,
	LTM_ADC_DOUT,
	LTM_B,
	LTM_DEN,
	LTM_G,
	LTM_GREST,
	LTM_HD,
	LTM_NCLK,
	LTM_R,
	LTM_SCEN,
	LTM_SDA,
	LTM_VD, 	

	//////////// HSMC, HSMC connect to mtlc - 7" LCD/Touch/Camera/G-sensor //////////
	LCD_B,
	LCD_DCLK,
	LCD_G,
	LCD_HSD,
	TOUCH_I2C_SCL,
	TOUCH_I2C_SDA,
	TOUCH_INT_n,
	LCD_R,
	LCD_VSD,
	
	LCD_DITH,
	LCD_MODE,
	LCD_POWER_CTL,
	LCD_UPDN,
	LCD_RSTB,
	LCD_DE,
	LCD_SHLR,
	LCD_DIM,
	
	//D5M
	CAMERA_LVAL,
	CAMERA_PIXCLK,
	CAMERA_RESET_n,
	CAMERA_SCLK,
	CAMERA_SDATA,
	CAMERA_STROBE,
	CAMERA_TRIGGER,
	CAMERA_XCLKIN,
	CAMERA_D,
	CAMERA_FVAL,
	//LIGHT SENSOR
	LSENSOR_ADDR_SEL,
	LSENSOR_SCL,
	LSENSOR_SDA,
	LSENSOR_INT,
	//G_Sensor
	GSENSOR_CS_n,
	GSENSOR_INT1,
	GSENSOR_INT2,
	GSENSOR_ALT_ADDR,
	GSENSOR_SDA_SDI_SDIO,
	GSENSOR_SCL_SCLK
);

//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input		          		CLOCK_50;
input		          		CLOCK2_50;
input		          		CLOCK3_50;

//////////// KEY //////////
input		     [3:0]		KEY;

//////////// SW //////////
input		    [17:0]		SW;

//////////// SEG7 //////////
output		  [6:0]		HEX0;
output		  [6:0]		HEX1;
output		  [6:0]		HEX2;
output		  [6:0]		HEX3;
output		  [6:0]		HEX4;
output		  [6:0]		HEX5;
output		  [6:0]		HEX6;
output		  [6:0]		HEX7;


//////////// LED //////////
output		  [7:0]		LEDG;
output	    [17:0]		LEDR;

//////////// VGA //////////
output		  [7:0]		VGA_B;
output		        		VGA_BLANK_N;
output		        		VGA_CLK;
output		   [7:0]		VGA_G;
output		         	VGA_HS;
output		   [7:0]		VGA_R;
output		        		VGA_SYNC_N;
output		        		VGA_VS;

//////////// Audio //////////
input		          		AUD_ADCDAT;
inout		          		AUD_ADCLRCK;
inout		          		AUD_BCLK;
output		          	AUD_DACDAT;
inout		          		AUD_DACLRCK;
output		          	AUD_XCK;

//////////// I2C for Audio and Tv-Decode //////////
output		          	I2C_SCLK;
inout		          		I2C_SDAT;

//////////// TV Decoder 1 //////////
input		          		TD_CLK27;
input		     [7:0]		TD_DATA;
input		          		TD_HS;
output		          	TD_RESET_N;
input		          		TD_VS;

//////////// SDRAM //////////
output	    [12:0]		DRAM_ADDR;
output		  [1:0]		DRAM_BA;
output		        		DRAM_CAS_N;
output		        		DRAM_CKE;
output		        		DRAM_CLK;
output		        		DRAM_CS_N;
inout		    [31:0]		DRAM_DQ;
output		  [3:0]		DRAM_DQM;
output		         	DRAM_RAS_N;
output		         	DRAM_WE_N;

//////////// SRAM //////////
output	   [19:0]		SRAM_ADDR;
output		        		SRAM_CE_N;
inout		   [15:0]		SRAM_DQ;
output		          	SRAM_LB_N;
output		        		SRAM_OE_N;
output		        		SRAM_UB_N;
output		        		SRAM_WE_N;

//////////// Flash //////////
output	   [22:0]		FL_ADDR;
output		        		FL_CE_N;
inout		    [7:0]		FL_DQ;
output		        		FL_OE_N;
output		        		FL_RST_N;
input		          		FL_RY;
output		        		FL_WE_N;
output		        		FL_WP_N;

//////////// GPIO //////////
input		          		LTM_ADC_PENIRQ_n;
input		          		LTM_ADC_BUSY;
output		        		LTM_ADC_DCLK;
output		        		LTM_ADC_DIN;
input		          		LTM_ADC_DOUT;
output		   [7:0]		LTM_B;
output		        		LTM_DEN;
output		   [7:0]		LTM_G;
output		        		LTM_GREST;
output		        		LTM_HD;
output		        		LTM_NCLK;
output		   [7:0]		LTM_R;
output		        		LTM_SCEN;
inout		          		LTM_SDA;
output		        		LTM_VD;

//////////// HSMC, HSMC connect to mtlc - 7" LCD/Touch/Camera/G-sensor //////////
output		     [7:0]		LCD_B;
output		          		LCD_DCLK;
output		     [7:0]		LCD_G;
output		          		LCD_HSD;
output		          		TOUCH_I2C_SCL;
inout 		          		TOUCH_I2C_SDA;
input 		          		TOUCH_INT_n;
output		     [7:0]		LCD_R;
output		          		LCD_VSD;

output                     LCD_DITH;
output                     LCD_MODE;
output                     LCD_POWER_CTL;
output                     LCD_UPDN;
output                     LCD_RSTB;
output                     LCD_DE;
output                     LCD_SHLR;
output                     LCD_DIM;

//D5M
input		          		   CAMERA_LVAL;
input		          			CAMERA_PIXCLK;
output		          		CAMERA_RESET_n;
output		          		CAMERA_SCLK;
inout		          			CAMERA_SDATA;
input		          			CAMERA_STROBE;
output		        			CAMERA_TRIGGER;
output		        			CAMERA_XCLKIN;
input		    		[11:0]	CAMERA_D;
input		          			CAMERA_FVAL;
//LIGHT SENSOR
output                     LSENSOR_ADDR_SEL;
output                     LSENSOR_SCL;
inout                      LSENSOR_SDA;
input                      LSENSOR_INT;
//G_Sensor
output                     GSENSOR_CS_n;
input                      GSENSOR_INT1;
input                      GSENSOR_INT2;
output                     GSENSOR_ALT_ADDR;
inout                      GSENSOR_SDA_SDI_SDIO;
output                     GSENSOR_SCL_SCLK;

//=======================================================
//  Structural coding
//=======================================================
//define wire
  wire h_sync;
  wire v_sync;

  wire vga_base_clock;
  wire vga_clock; // *3 of the base clock
  wire [23:0] wire_VGA_DATA;
  wire wire_VGA_BLANK;
  wire wire_VGA_HS;
  wire wire_VGA_VS;

  wire lcd_base_clock;
  wire lcd_clock; // *3 of the base clock
  wire [23:0] LCD_DATA;
  wire LCD_BLANK;
  wire LCD_HS;
  wire LCD_VS;
  wire clk_100;
  wire clk_mtlc;
  wire locked;
 
  //wire clk_touch;
assign LCD_MODE = 1'b0;  //HV sync mode
assign LCD_RSTB = locked &KEY[3]; //NO RESET
assign LCD_DIM  = 1'b1;
assign LCD_POWER_CTL = 1'b1;
assign LCD_SHLR  	= 1'b1;
assign LCD_UPDN 	= 1'b0;
  
DE2_115_SOPC DE2_115_SOPC_inst
    (
      //clock
      .clk_50                                        (CLOCK_50),
      .altpll_sdram_clk                              (DRAM_CLK),
      .altpll_mtlc_clk                               (clk_mtlc),
		.altpll_camera_clk                             (CAMERA_XCLKIN),
		.locked_from_the_altpll_0                      (locked),
      //reset
      .reset_n                                       (1'b1),
      
      //button
      .in_port_to_the_button_pio                     (KEY),
      
      //LED
      .out_port_from_the_led_pio                     (LEDG),
      
      
      // the_multi_touch
      .TOUCH_I2C_SCL_from_the_multi_touch            (TOUCH_I2C_SCL),
      .TOUCH_I2C_SDA_to_and_from_the_multi_touch     (TOUCH_I2C_SDA),
      .TOUCH_INT_n_to_the_multi_touch                (TOUCH_INT_n),
      
      //sram
      .SRAM_ADDR_from_the_sram                       (SRAM_ADDR),
      .SRAM_CE_n_from_the_sram                       (SRAM_CE_N),
      .SRAM_DQ_to_and_from_the_sram                  (SRAM_DQ),
      .SRAM_LB_n_from_the_sram                       (SRAM_LB_N),
      .SRAM_OE_n_from_the_sram                       (SRAM_OE_N),
      .SRAM_UB_n_from_the_sram                       (SRAM_UB_N),
      .SRAM_WE_n_from_the_sram                       (SRAM_WE_N),
      
      //TV and audio i2c
      .bidir_port_to_and_from_the_av_i2c_data_pio    (I2C_SDAT),
      .out_port_from_the_av_i2c_clk_pio              (I2C_SCLK),
		
		//CAMERA
		.vid_clk_to_the_alt_vip_cti_0                   (CAMERA_PIXCLK),
		.vid_data_to_the_alt_vip_cti_0                  ({sCCD_R[11:4],sCCD_G[11:4],sCCD_B[11:4]}),
		.vid_datavalid_to_the_alt_vip_cti_0             (rCCD_LVAL),
		.vid_f_to_the_alt_vip_cti_0                     (1'b0),
		.vid_h_sync_to_the_alt_vip_cti_0                (rCCD_LVAL),
		.vid_locked_to_the_alt_vip_cti_0                (DLY_RST_3),
		.vid_v_sync_to_the_alt_vip_cti_0                (rCCD_FVAL),
      
      //vga
      .vid_clk_to_the_alt_vip_itc_0                  (clk_mtlc),
      .vid_data_from_the_alt_vip_itc_0               (wire_VGA_DATA),
      .vid_datavalid_from_the_alt_vip_itc_0          (),
      .vid_h_sync_from_the_alt_vip_itc_0             (wire_VGA_HS),
      .vid_v_sync_from_the_alt_vip_itc_0             (wire_VGA_VS),
      
      //tpad
      .vid_clk_to_the_alt_vip_itc_1                  (clk_mtlc),
      .vid_data_from_the_alt_vip_itc_1               (LCD_DATA),
      .vid_datavalid_from_the_alt_vip_itc_1          (),
      .vid_h_sync_from_the_alt_vip_itc_1             (LCD_HS),
      .vid_v_sync_from_the_alt_vip_itc_1             (LCD_VS),
      
      //sdram
      .zs_addr_from_the_sdram                        (DRAM_ADDR),
      .zs_ba_from_the_sdram                          (DRAM_BA),
      .zs_cas_n_from_the_sdram                       (DRAM_CAS_N),
      .zs_cke_from_the_sdram                         (DRAM_CKE),
      .zs_cs_n_from_the_sdram                        (DRAM_CS_N),
      .zs_dq_to_and_from_the_sdram                   (DRAM_DQ),
      .zs_dqm_from_the_sdram                         (DRAM_DQM),
      .zs_ras_n_from_the_sdram                       (DRAM_RAS_N),
      .zs_we_n_from_the_sdram                        (DRAM_WE_N),
		
		// the_tri_state_bridge_flash_avalon_slave
      .address_to_the_cfi_flash(FL_ADDR),
      .read_n_to_the_cfi_flash(FL_OE_N),
      .select_n_to_the_cfi_flash(FL_CE_N),
      .tri_state_bridge_flash_data(FL_DQ),
      .write_n_to_the_cfi_flash(FL_WE_N)
    );

	 // Flash Config
assign	FL_RST_N = 1'b1;
assign	FL_WP_N = 1'b1;
////vga signal assignments
assign VGA_SYNC_N = 1'b0;
assign VGA_BLANK_N = 1'b1;

assign VGA_CLK = clk_mtlc;

assign VGA_HS = ~LCD_HS;
assign VGA_VS = ~LCD_VS;

assign VGA_R = LCD_DATA[23:16];
assign VGA_G = LCD_DATA[15:8];
assign VGA_B = LCD_DATA[7:0];

////
assign LCD_HSD = ~LCD_HS;
assign LCD_VSD = ~LCD_VS;

assign LCD_R = LCD_DATA[23:16];
assign LCD_G = LCD_DATA[15:8];
assign LCD_B = LCD_DATA[7:0];

assign LCD_DCLK = clk_mtlc;

//////////////////////D5M//////////////////////////////
wire	[11:0]	mCCD_DATA;
wire			mCCD_DVAL;
wire			mCCD_DVAL_d;
wire	[15:0]	X_Cont;
wire	[15:0]	Y_Cont;
wire	[9:0]	X_ADDR;
wire	[31:0]	Frame_Cont;
wire			DLY_RST_0;
wire			DLY_RST_1;
wire			DLY_RST_2;
wire			DLY_RST_3;
wire			DLY_RST_4;

reg		[11:0]	rCCD_DATA;
reg				rCCD_LVAL;
reg				rCCD_FVAL;
wire	[11:0]	sCCD_R;
wire	[11:0]	sCCD_G;
wire	[11:0]	sCCD_B;
wire			sCCD_DVAL;
//power on start
wire             auto_start;

// D5M
assign	CAMERA_TRIGGER	    =	1'b1;  // tRIGGER
assign	CAMERA_RESET_n	    =	DLY_RST_1;
assign	LEDR		=	SW;
//assign	LEDG		=	Y_Cont;

///////////////////// D5M//////////////////////////////
//auto start when power on
assign auto_start = ((KEY[0])&&(DLY_RST_3)&&(!DLY_RST_4))? 1'b1:1'b0;

always@(posedge CAMERA_PIXCLK)
begin
	rCCD_DATA	<= CAMERA_D;
	rCCD_LVAL	<=	CAMERA_LVAL;
	rCCD_FVAL	<=	CAMERA_FVAL;
end
//reset signals
Reset_Delay			u2	(	.iCLK(CLOCK2_50),
							.iRST(KEY[0]),
							.oRST_0(DLY_RST_0),
							.oRST_1(DLY_RST_1),
							.oRST_2(DLY_RST_2),
							.oRST_3(DLY_RST_3), //auto-start start point
							.oRST_4(DLY_RST_4)  //auto-start end point
						);
//cmos sensor capture
CCD_Capture			u3	(	.oDATA(mCCD_DATA),
							.oDVAL(mCCD_DVAL),
							.oX_Cont(X_Cont),
							.oY_Cont(Y_Cont),
							.oFrame_Cont(Frame_Cont),
							.iDATA(rCCD_DATA),
							.iFVAL(rCCD_FVAL),
							.iLVAL(rCCD_LVAL),
							.iSTART((!KEY[3])| auto_start),
							.iEND(!KEY[2]),
							.iCLK(~CAMERA_PIXCLK),
							.iRST(DLY_RST_2)
						);
//raw data to RGB conversion
RAW2RGB				u4	(	.iCLK(CAMERA_PIXCLK),
							.iRST_n(DLY_RST_1),
							.iData(mCCD_DATA),
							.iDval(mCCD_DVAL),
							.oRed(sCCD_R),
							.oGreen(sCCD_G),
							.oBlue(sCCD_B),
							.oDval(sCCD_DVAL),
							.iMIRROR(SW[17]),
							.iX_Cont(X_Cont),
							.iY_Cont(Y_Cont)
						);
//frame data display
SEG7_LUT_8 			u5	(	.oSEG0(HEX0),.oSEG1(HEX1),
							.oSEG2(HEX2),.oSEG3(HEX3),
							.oSEG4(HEX4),.oSEG5(HEX5),
							.oSEG6(HEX6),.oSEG7(HEX7),
							.iDIG(Frame_Cont[31:0])
						);
						
//cmos sensor configuration
I2C_CCD_Config 		u8	(	//	Host Side
							.iCLK(CLOCK2_50),
							.iRST_N(DLY_RST_2),
							.iEXPOSURE_ADJ(KEY[1]),
							.iEXPOSURE_DEC_p(SW[0]),
							.iMIRROR_SW(SW[17]),
							//	I2C Side
							.I2C_SCLK(CAMERA_SCLK),
							.I2C_SDAT(CAMERA_SDATA)
						);

endmodule


